Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/ClassificationImportDialog.Designer.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/ClassificationImportDialog.Designer.cs	(revision 17784)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/ClassificationImportDialog.Designer.cs	(revision 17785)
@@ -87,5 +87,5 @@
       this.ProblemDataSettingsGroupBox.Controls.Add(this.TargetVariableComboBox);
       this.ProblemDataSettingsGroupBox.Controls.Add(this.UniformDistributionOfClassesCheckbox);
-      this.ProblemDataSettingsGroupBox.Size = new System.Drawing.Size(447, 285);
+      this.ProblemDataSettingsGroupBox.Size = new System.Drawing.Size(447, 255);
       this.ProblemDataSettingsGroupBox.Controls.SetChildIndex(this.UniformDistributionOfClassesCheckbox, 0);
       this.ProblemDataSettingsGroupBox.Controls.SetChildIndex(this.TargetVariableComboBox, 0);
@@ -110,5 +110,5 @@
       // 
       this.PreviewDatasetMatrix.Location = new System.Drawing.Point(6, 134);
-      this.PreviewDatasetMatrix.Size = new System.Drawing.Size(435, 145);
+      this.PreviewDatasetMatrix.Size = new System.Drawing.Size(435, 115);
       // 
       // PreviewLabel
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportDialog.Designer.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportDialog.Designer.cs	(revision 17784)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportDialog.Designer.cs	(revision 17785)
@@ -63,4 +63,7 @@
       this.SeparatorComboBox = new System.Windows.Forms.ComboBox();
       this.CSVSettingsGroupBox = new System.Windows.Forms.GroupBox();
+      this.VectorSeparatorInfoLabel = new System.Windows.Forms.Label();
+      this.VectorSeparatorComboBox = new System.Windows.Forms.ComboBox();
+      this.VectorSeparatorLabel = new System.Windows.Forms.Label();
       this.EncodingInfoLabel = new System.Windows.Forms.Label();
       this.EncodingLabel = new System.Windows.Forms.Label();
@@ -97,5 +100,5 @@
       this.OkButton.DialogResult = System.Windows.Forms.DialogResult.OK;
       this.OkButton.Enabled = false;
-      this.OkButton.Location = new System.Drawing.Point(303, 422);
+      this.OkButton.Location = new System.Drawing.Point(303, 528);
       this.OkButton.Name = "OkButton";
       this.OkButton.Size = new System.Drawing.Size(75, 23);
@@ -106,5 +109,5 @@
       // TrainingTestTrackBar
       // 
-      this.TrainingTestTrackBar.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+      this.TrainingTestTrackBar.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
             | System.Windows.Forms.AnchorStyles.Right)));
       this.TrainingTestTrackBar.Location = new System.Drawing.Point(6, 43);
@@ -141,5 +144,5 @@
       this.CancellationButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
       this.CancellationButton.DialogResult = System.Windows.Forms.DialogResult.Cancel;
-      this.CancellationButton.Location = new System.Drawing.Point(384, 422);
+      this.CancellationButton.Location = new System.Drawing.Point(384, 528);
       this.CancellationButton.Name = "CancellationButton";
       this.CancellationButton.Size = new System.Drawing.Size(75, 23);
@@ -250,6 +253,9 @@
       // CSVSettingsGroupBox
       // 
-      this.CSVSettingsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
+      this.CSVSettingsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.CSVSettingsGroupBox.Controls.Add(this.VectorSeparatorInfoLabel);
+      this.CSVSettingsGroupBox.Controls.Add(this.VectorSeparatorComboBox);
+      this.CSVSettingsGroupBox.Controls.Add(this.VectorSeparatorLabel);
       this.CSVSettingsGroupBox.Controls.Add(this.EncodingInfoLabel);
       this.CSVSettingsGroupBox.Controls.Add(this.EncodingLabel);
@@ -267,14 +273,48 @@
       this.CSVSettingsGroupBox.Location = new System.Drawing.Point(12, 32);
       this.CSVSettingsGroupBox.Name = "CSVSettingsGroupBox";
-      this.CSVSettingsGroupBox.Size = new System.Drawing.Size(447, 153);
+      this.CSVSettingsGroupBox.Size = new System.Drawing.Size(447, 183);
       this.CSVSettingsGroupBox.TabIndex = 16;
       this.CSVSettingsGroupBox.TabStop = false;
       this.CSVSettingsGroupBox.Text = "CSV Settings";
       // 
+      // VectorSeparatorInfoLabel
+      // 
+      this.VectorSeparatorInfoLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.VectorSeparatorInfoLabel.Image = HeuristicLab.Common.Resources.VSImageLibrary.Information;
+      this.VectorSeparatorInfoLabel.Location = new System.Drawing.Point(417, 100);
+      this.VectorSeparatorInfoLabel.Name = "VectorSeparatorInfoLabel";
+      this.VectorSeparatorInfoLabel.Size = new System.Drawing.Size(24, 25);
+      this.VectorSeparatorInfoLabel.TabIndex = 30;
+      this.VectorSeparatorInfoLabel.Tag = "Select the decimal separator used to for double values";
+      this.ToolTip.SetToolTip(this.VectorSeparatorInfoLabel, "If a value contains a Vector Separator it is converted to a Vector column with th" +
+        "e value split on the Vector Separator symbol.");
+      // 
+      // VectorSeparatorComboBox
+      // 
+      this.VectorSeparatorComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.VectorSeparatorComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.VectorSeparatorComboBox.Enabled = false;
+      this.VectorSeparatorComboBox.FormattingEnabled = true;
+      this.VectorSeparatorComboBox.Location = new System.Drawing.Point(111, 100);
+      this.VectorSeparatorComboBox.Name = "VectorSeparatorComboBox";
+      this.VectorSeparatorComboBox.Size = new System.Drawing.Size(300, 21);
+      this.VectorSeparatorComboBox.TabIndex = 29;
+      this.VectorSeparatorComboBox.SelectionChangeCommitted += new System.EventHandler(this.CSVFormatComboBoxSelectionChangeCommitted);
+      // 
+      // VectorSeparatorLabel
+      // 
+      this.VectorSeparatorLabel.AutoSize = true;
+      this.VectorSeparatorLabel.Location = new System.Drawing.Point(6, 104);
+      this.VectorSeparatorLabel.Name = "VectorSeparatorLabel";
+      this.VectorSeparatorLabel.Size = new System.Drawing.Size(90, 13);
+      this.VectorSeparatorLabel.TabIndex = 28;
+      this.VectorSeparatorLabel.Text = "Vector Separator:";
+      // 
       // EncodingInfoLabel
       // 
       this.EncodingInfoLabel.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
       this.EncodingInfoLabel.Image = HeuristicLab.Common.Resources.VSImageLibrary.Information;
-      this.EncodingInfoLabel.Location = new System.Drawing.Point(421, 102);
+      this.EncodingInfoLabel.Location = new System.Drawing.Point(421, 130);
       this.EncodingInfoLabel.Name = "EncodingInfoLabel";
       this.EncodingInfoLabel.Size = new System.Drawing.Size(16, 16);
@@ -287,5 +327,5 @@
       // 
       this.EncodingLabel.AutoSize = true;
-      this.EncodingLabel.Location = new System.Drawing.Point(6, 103);
+      this.EncodingLabel.Location = new System.Drawing.Point(6, 130);
       this.EncodingLabel.Name = "EncodingLabel";
       this.EncodingLabel.Size = new System.Drawing.Size(52, 13);
@@ -300,5 +340,5 @@
       this.EncodingComboBox.Enabled = false;
       this.EncodingComboBox.FormattingEnabled = true;
-      this.EncodingComboBox.Location = new System.Drawing.Point(111, 100);
+      this.EncodingComboBox.Location = new System.Drawing.Point(111, 127);
       this.EncodingComboBox.Name = "EncodingComboBox";
       this.EncodingComboBox.Size = new System.Drawing.Size(300, 21);
@@ -309,5 +349,5 @@
       // 
       this.CheckboxColumnNames.AutoSize = true;
-      this.CheckboxColumnNames.Location = new System.Drawing.Point(9, 127);
+      this.CheckboxColumnNames.Location = new System.Drawing.Point(9, 154);
       this.CheckboxColumnNames.Name = "CheckboxColumnNames";
       this.CheckboxColumnNames.Size = new System.Drawing.Size(144, 17);
@@ -366,7 +406,7 @@
       this.ProblemDataSettingsGroupBox.Controls.Add(this.TrainingTestTrackBar);
       this.ProblemDataSettingsGroupBox.Controls.Add(this.ShuffleDataCheckbox);
-      this.ProblemDataSettingsGroupBox.Location = new System.Drawing.Point(12, 191);
+      this.ProblemDataSettingsGroupBox.Location = new System.Drawing.Point(12, 221);
       this.ProblemDataSettingsGroupBox.Name = "ProblemDataSettingsGroupBox";
-      this.ProblemDataSettingsGroupBox.Size = new System.Drawing.Size(447, 225);
+      this.ProblemDataSettingsGroupBox.Size = new System.Drawing.Size(447, 301);
       this.ProblemDataSettingsGroupBox.TabIndex = 17;
       this.ProblemDataSettingsGroupBox.TabStop = false;
@@ -416,5 +456,5 @@
       this.PreviewDatasetMatrix.ShowRowsAndColumnsTextBox = false;
       this.PreviewDatasetMatrix.ShowStatisticalInformation = false;
-      this.PreviewDatasetMatrix.Size = new System.Drawing.Size(435, 111);
+      this.PreviewDatasetMatrix.Size = new System.Drawing.Size(435, 187);
       this.PreviewDatasetMatrix.TabIndex = 0;
       // 
@@ -424,5 +464,5 @@
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
-      this.ClientSize = new System.Drawing.Size(471, 457);
+      this.ClientSize = new System.Drawing.Size(471, 563);
       this.Controls.Add(this.ProblemDataSettingsGroupBox);
       this.Controls.Add(this.CSVSettingsGroupBox);
@@ -480,4 +520,7 @@
     protected System.Windows.Forms.Label EncodingLabel;
     protected System.Windows.Forms.ComboBox EncodingComboBox;
+    protected System.Windows.Forms.Label VectorSeparatorInfoLabel;
+    protected System.Windows.Forms.ComboBox VectorSeparatorComboBox;
+    protected System.Windows.Forms.Label VectorSeparatorLabel;
   }
 }
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportDialog.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportDialog.cs	(revision 17784)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisImportDialog.cs	(revision 17785)
@@ -29,4 +29,5 @@
 using HeuristicLab.Core.Views;
 using HeuristicLab.Problems.DataAnalysis;
+using DoubleVector = MathNet.Numerics.LinearAlgebra.Vector<double>;
 
 namespace HeuristicLab.Problems.Instances.DataAnalysis.Views {
@@ -55,4 +56,13 @@
     };
 
+    private static readonly List<KeyValuePair<char?, string>> POSSIBLE_VECTOR_SEPARATORS =
+      new List<KeyValuePair<char?, string>>{
+        new KeyValuePair<char?, string>(null, "None"),
+        new KeyValuePair<char?, string>(',', ", (Comma)"),
+        new KeyValuePair<char?, string>(';', "; (Semicolon)"),
+        new KeyValuePair<char?, string>(' ', "' ' (Space)"),
+        new KeyValuePair<char?, string>('|', "| (Pipe)")
+      };
+
     private static readonly List<KeyValuePair<Encoding, string>> POSSIBLE_ENCODINGS =
       new List<KeyValuePair<Encoding, string>> {
@@ -82,4 +92,5 @@
           NumberFormatInfo = (NumberFormatInfo)DecimalSeparatorComboBox.SelectedValue,
           DateTimeFormatInfo = (DateTimeFormatInfo)DateTimeFormatComboBox.SelectedValue,
+          VectorSeparator = (char?)VectorSeparatorComboBox.SelectedValue,
           VariableNamesAvailable = CheckboxColumnNames.Checked,
           Encoding = (Encoding)EncodingComboBox.SelectedValue
@@ -97,4 +108,7 @@
       DecimalSeparatorComboBox.ValueMember = "Key";
       DecimalSeparatorComboBox.DisplayMember = "Value";
+      VectorSeparatorComboBox.DataSource = POSSIBLE_VECTOR_SEPARATORS;
+      VectorSeparatorComboBox.ValueMember = "Key";
+      VectorSeparatorComboBox.DisplayMember = "Value";
       DateTimeFormatComboBox.DataSource = POSSIBLE_DATETIME_FORMATS;
       DateTimeFormatComboBox.ValueMember = "Key";
@@ -125,4 +139,5 @@
       SeparatorComboBox.Enabled = true;
       DecimalSeparatorComboBox.Enabled = true;
+      VectorSeparatorComboBox.Enabled = true;
       DateTimeFormatComboBox.Enabled = true;
       EncodingComboBox.Enabled = true;
@@ -132,5 +147,6 @@
         NumberFormat = (NumberFormatInfo)DecimalSeparatorComboBox.SelectedValue,
         DateTimeFormat = (DateTimeFormatInfo)DateTimeFormatComboBox.SelectedValue,
-        ColumnSeparator = (char)SeparatorComboBox.SelectedValue
+        ColumnSeparator = (char)SeparatorComboBox.SelectedValue,
+        VectorSeparator = (char?)VectorSeparatorComboBox.SelectedValue
       };
       CheckboxColumnNames.Checked = csvParser.AreColumnNamesInFirstLine(ProblemTextBox.Text, formatOptions);
@@ -158,5 +174,6 @@
           NumberFormat = (NumberFormatInfo)DecimalSeparatorComboBox.SelectedValue,
           DateTimeFormat = (DateTimeFormatInfo)DateTimeFormatComboBox.SelectedValue,
-          ColumnSeparator = (char)SeparatorComboBox.SelectedValue
+          ColumnSeparator = (char)SeparatorComboBox.SelectedValue,
+          VectorSeparator = (char?)VectorSeparatorComboBox.SelectedValue
         };
         csvParser.Parse(ProblemTextBox.Text, formatOptions, CheckboxColumnNames.Checked, lineLimit: 500);
@@ -195,6 +212,8 @@
         } else if (csvParser.Values[i] is List<DateTime>) {
           variableNamesWithType[i] += " (DateTime)";
+        } else if (csvParser.Values[i] is List<DoubleVector>) {
+          variableNamesWithType[i] += " (Double-Vector)";
         } else {
-          throw new ArgumentException("The variable values must be of type List<double>, List<string> or List<DateTime>");
+          throw new ArgumentException("The variable values must be of type List<double>, List<string>, List<DateTime> or List<DoubleVector>");
         }
       }
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/HeuristicLab.Problems.Instances.DataAnalysis.Views-3.3.csproj
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/HeuristicLab.Problems.Instances.DataAnalysis.Views-3.3.csproj	(revision 17784)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/HeuristicLab.Problems.Instances.DataAnalysis.Views-3.3.csproj	(revision 17785)
@@ -81,4 +81,8 @@
     <Reference Include="HeuristicLab.Optimization-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
     <Reference Include="HeuristicLab.Visualization.ChartControlsExtensions-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL" />
+    <Reference Include="MathNet.Numerics, Version=4.9.0.0, Culture=neutral, PublicKeyToken=cd8b63ad3d691a37, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\bin\MathNet.Numerics.dll</HintPath>
+    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core" />
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/Plugin.cs.frame
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/Plugin.cs.frame	(revision 17784)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/Plugin.cs.frame	(revision 17785)
@@ -36,4 +36,5 @@
   [PluginDependency("HeuristicLab.Problems.Instances.DataAnalysis", "3.3")]
   [PluginDependency("HeuristicLab.Problems.Instances.Views", "3.3")]
+  [PluginDependency("HeuristicLab.MathNet.Numerics", "4.9.0")]
   public class HeuristicLabProblemsInstancesDataAnalysisViewsPlugin : PluginBase {
   }
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/RegressionImportDialog.Designer.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/RegressionImportDialog.Designer.cs	(revision 17784)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/RegressionImportDialog.Designer.cs	(revision 17785)
@@ -66,4 +66,5 @@
       this.ProblemDataSettingsGroupBox.Controls.Add(this.TargetVariableLabel);
       this.ProblemDataSettingsGroupBox.Controls.Add(this.TargetVariableComboBox);
+      this.ProblemDataSettingsGroupBox.Size = new System.Drawing.Size(447, 194);
       this.ProblemDataSettingsGroupBox.Controls.SetChildIndex(this.PreviewLabel, 0);
       this.ProblemDataSettingsGroupBox.Controls.SetChildIndex(this.ShuffelInfoLabel, 0);
@@ -78,4 +79,7 @@
       this.ProblemDataSettingsGroupBox.Controls.SetChildIndex(this.ErrorTextBox, 0);
       // 
+      // PreviewDatasetMatrix
+      // 
+      this.PreviewDatasetMatrix.Size = new System.Drawing.Size(435, 80);
       // TargetVariableComboBox
       // 
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisCSVFormat.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisCSVFormat.cs	(revision 17784)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisCSVFormat.cs	(revision 17785)
@@ -28,4 +28,5 @@
     public NumberFormatInfo NumberFormatInfo { get; set; }
     public DateTimeFormatInfo DateTimeFormatInfo { get; set; }
+    public char? VectorSeparator { get; set; }
     public bool VariableNamesAvailable { get; set; }
     public Encoding Encoding { get; set; }
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisInstanceProvider.cs
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisInstanceProvider.cs	(revision 17784)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/DataAnalysisInstanceProvider.cs	(revision 17785)
@@ -46,5 +46,8 @@
       };
       var formatOptions = new TableFileFormatOptions {
-        NumberFormat = csvFormat.NumberFormatInfo, DateTimeFormat = csvFormat.DateTimeFormatInfo, ColumnSeparator = csvFormat.Separator
+        NumberFormat = csvFormat.NumberFormatInfo,
+        DateTimeFormat = csvFormat.DateTimeFormatInfo,
+        ColumnSeparator = csvFormat.Separator,
+        VectorSeparator = csvFormat.VectorSeparator
       };
       csvFileParser.Parse(path, formatOptions, csvFormat.VariableNamesAvailable);
Index: /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 17784)
+++ /branches/3040_VectorBasedGP/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 17785)
@@ -24,5 +24,5 @@
     <WarningLevel>4</WarningLevel>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>default</LangVersion>
+    <LangVersion>7</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -34,5 +34,5 @@
     <WarningLevel>4</WarningLevel>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>default</LangVersion>
+    <LangVersion>7</LangVersion>
   </PropertyGroup>
   <PropertyGroup>
@@ -56,5 +56,5 @@
     <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>default</LangVersion>
+    <LangVersion>7</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x86'">
@@ -74,5 +74,5 @@
     <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>default</LangVersion>
+    <LangVersion>7</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
@@ -90,5 +90,5 @@
     <CodeAnalysisRuleDirectories>;C:\Program Files (x86)\Microsoft Visual Studio 10.0\Team Tools\Static Analysis Tools\FxCop\\Rules</CodeAnalysisRuleDirectories>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>default</LangVersion>
+    <LangVersion>7</LangVersion>
   </PropertyGroup>
   <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
@@ -108,5 +108,5 @@
     <CodeAnalysisIgnoreBuiltInRules>false</CodeAnalysisIgnoreBuiltInRules>
     <Prefer32Bit>false</Prefer32Bit>
-    <LangVersion>default</LangVersion>
+    <LangVersion>7</LangVersion>
   </PropertyGroup>
   <ItemGroup>